FLASHROM(8)

NAME
flashrom - read, write, and erase BIOS/ROM/flash chips

SYNOPSIS
flashrom [-rwvEVfLhR] [-c chipname] [-s exclude_start] [-e exclude_end]
         [-m vendor:part] [-l file.layout] [-i image_name] [file]

DESCRIPTION
flashrom is a utility for reading, writing, and erasing flash ROM chips. It's often used to flash BIOS/coreboot/firmware images.

It supports a wide range of DIP32, PLCC32, DIP8, SO8/SOIC8, TSOP32, and TSOP40 chips, which use various protocols such as LPC, FWH, parallel flash, or SPI.

(see http://coreboot.org for details on coreboot)

OPTIONS
If no file is specified, then all that happens is that flash info is dumped and the flash chip is set to writable.

-r, --read <file>
    Read flash ROM contents and save them into the given <file>.

-w, --write <file>
    Write file into flash ROM (default when <file> is specified).

-v, --verify <file>
    Verify the flash ROM contents against the given <file>.

-E, --erase
    Erase the flash ROM chip.

-V, --verbose
    More verbose output.

-c, --chip <chipname>
    Probe only for specified flash ROM chip.

-s, --estart <addr>
    Exclude start position (obsolete).

-e, --eend <addr>
    Exclude end postion (obsolete).

-m, --mainboard <[vendor:]part>
    Override mainboard settings. This option is needed for some mainboards, see the flashrom --list-supported output for a list. The vendor is not required when the board name is unique.

-f, --force
    Force write without checking whether the ROM image file is really meant to be used on this board.

    Note: This check only works while coreboot is running, and only for those boards where the coreboot code supports it.

-l, --layout <file>
    Read ROM layout from <file>.

-i, --image <name>
    Only flash image <name> from flash layout.

-L, --list-supported
    List the ROM chips, chipsets, and mainboards supported by flashrom. The list of mainboards consists of those boards which need a special ROM write-enable function for flashrom to work.

    There are many other boards which will work out of the box, without such special support in flashrom. Some of the known-good/known-bad and tested ones are listed at http://coreboot.org/Flashrom#Supported_mainboards, but the list is not exhaustive, of course.

    Please let us know if you can verify other boards to work or not work out of the box.

-h, --help
    Show a help text and exit.

-R, --version
    Show version information and exit.

EXIT STATUS
flashrom exits with 0 on success, 1 on most failures but with 2 if /dev/mem (/dev/xsvc on Solaris) can not be opened and with 3 if a call to mmap() fails.

BUGS
Please report any bugs at http://tracker.coreboot.org/trac/coreboot/newticket, or on the coreboot mailing list (http://coreboot.org/Mailinglist).

LICENCE
flashrom is covered by the GNU General Public License (GPL), version 2. Some files are additionally available under the GPL (version 2, or any later version).

COPYRIGHT
Please see the individual files.

AUTHORS
Carl-Daniel Hailfinger
Claus Gindhart <claus.gindhart@kontron.com>
Dominik Geyer <dominik.geyer@kontron.com>
Eric Biederman <ebiederman@lnxi.com>
Giampiero Giancipoli <gianci@email.it>
Joe Bao <Zheng.Bao@amd.com>
Luc Verhaegen <libv@skynet.be>
Markus Boas <ryven@ryven.de>
Nikolay Petukhov <nikolay.petukhov@gmail.com>
Peter Stuge <peter@stuge.se>
Reinder E.N. de Haan <lb_reha@mveas.com>
Ronald G. Minnich <rminnich@gmail.com>
Ronald Hoogenboom <ronald@zonnet.nl>
Stefan Reinauer <stepan@coresystems.de>
Stefan Wildemann <stefan.wildemann@kontron.com>
Steven James <pyro@linuxlabs.com>
Uwe Hermann <uwe@hermann-uwe.de>
Wang Qingpei <Qingpei.Wang@amd.com>
Yinghai Lu <yinghai.lu@amd.com>
some others

This manual page was written by Uwe Hermann <uwe@hermann-uwe.de>. It is licensed under the terms of the GNU GPL (version 2 or later).